unit CBssBC;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Quickrep, ssBC, CB3Party, Printers;

type
  TCBssBarcode = class(TCustomControl)
  private
    FBarcode : TssBarcode;

  protected
    procedure Notification( AComponent: TComponent; Operation: TOperation); override;
    procedure SetBarcode(Value : TssBarcode);
    constructor Create(AOwner : TComponent); override;
  public
    procedure CBPrint (var msg: TWPrintMes); message CB_PRINT;
    procedure Paint; override;
  published
    property Barcode : TssBarcode read FBarcode write SetBarcode;
  end;

procedure Register;

implementation

constructor TCBssBarcode.Create(AOwner : TComponent);

begin
  inherited Create(AOwner);
  Width:=200;
  Height:=200;
end;

procedure TCBssBarcode.SetBarcode(Value : TssBarcode);

begin
  FBarcode := Value;
  Invalidate;
end;

procedure TCBssBarcode.Paint;

begin
  if Assigned(FBarcode) then
  begin
    Width := FBarCode.Width;
    Height := FBarcode.Height;
    try
      FBarcode.DataBits := FBarcode.CreateDatabits(Screen.PixelsPerInch);
      FBarcode.AODataBits := FBarcode.CreateAODatabits(Screen.PixelsPerInch);
    finally
      FBarcode.DrawBarcode(Self.Canvas,0,0, Screen.PixelsPerInch);
    end;
  end
  else
  begin
    if (csDesigning in ComponentState) then
    with Canvas do
    begin
      Brush.Color := Self.Color;
      Brush.Style := bsSolid;
      FillRect(ClientRect);
      Pen.Style := psDash;
      Brush.Style := bsClear;
      Rectangle(0, 0, Width, Height);
      Pen.Style := psSolid;
    end;
  end;
end;


procedure TCBssBarcode.CBPrint (var msg: TWPrintMes);
begin
  if Assigned(FBarcode) then
  begin
    try
      FBarcode.DataBits := FBarcode.CreateDatabits(Printer.Canvas.Font.PixelsPerInch);
      FBarcode.AODataBits := FBarcode.CreateAODatabits(Printer.Canvas.Font.PixelsPerInch);

    finally
      FBarcode.DrawBarcode(msg.CBPrint^.Gdi.MyCanvas,msg.CBPrint^.Rect.Left{+Left},
      	msg.CBPrint^.Rect.Top{+Top}, Printer.Canvas.Font.PixelsPerInch);
    end;
  end;
end;

procedure TCBssBarcode.Notification( AComponent: TComponent; Operation: TOperation);

begin
  inherited Notification(AComponent, Operation);
  if (Operation=opRemove) and (AComponent=FBarcode) then
    SetBarcode(nil);
end;

procedure Register;
begin
  RegisterComponents('CB3Party', [TCBssBarcode]);
end;

end.
